/*

      I2C EEPROM
   
 ,         ))))
     I2C,     
,      ,      .

#define TWINT           0b10000000
#define TWEA            0b01000000
#define TWSTA           0b00100000
#define TWSTO           0b00010000
#define TWWC            0b00001000
#define TWEN            0b00000100
#define TWIE            0b00000001

//#define START   0b10100101
//#define STOP    0b10010101
#define SLA_W   0b10100000
#define SLA_R   0b10100001


void a_i2c_write(unsigned char data)
{
        TWCR = TWINT | TWSTA | TWEN;
        while (!(TWCR & TWINT));
        printf("\r\n 1 TWSR = 0x%X ; TWCR = %X \r\n ",TWSR,TWCR);

        TWDR=SLA_W;
        TWCR = TWINT | TWEN;
        while (!(TWCR & TWINT));
        printf("\r\n 2 TWSR = 0x%X ; TWCR = %X \r\n ",TWSR,TWCR);
                        
        TWDR=data;
        TWCR = TWINT | TWEN;
        while (!(TWCR & TWINT));
        printf("\r\n 3 TWSR = 0x%X ; TWCR = %X \r\n ",TWSR,TWCR);
        TWCR = TWINT | TWSTO | TWEN | TWEA;
}

unsigned char a_I2C_send_data()
{
        
        a_i2c_write(33);
        
        TWCR = TWINT | TWSTA | TWEN;
        while (!(TWCR & TWINT));
        printf("\r\n 4 TWSR = 0x%X ; TWCR = %X \r\n ",TWSR,TWCR);
        
        TWDR=SLA_R;
        TWCR = TWINT | TWEN;
        while (!(TWCR & TWINT));
        printf("\r\n 5 TWSR = 0x%X ; TWCR = %X \r\n ",TWSR,TWCR);

        printf("\r\n 6 TWDR = 0x%X \r\n \r\n ",TWDR);

        
        return TWDR;
}

void a_i2c_init(void)
{
        // TWI Status Register  TWSR
        //  - Bits 7..3  TWS: TWI Status
        //  - Bit 2  Res: Reserved Bit
        //  - Bits 1..0  TWPS: TWI Prescaler Bits
        TWSR=0x00;
        
        // Bits 7..0  TWI Bit Rate Register
        // Bit Rate: 87,771 kHz
        TWBR=0x22;
        
        // TWI (Slave) Address Register
        //  - Bits 7..1  TWA: TWI (Slave) Address Register
        //  - Bit 0  TWGCE: TWI General Call Recognition Enable Bit
        TWAR=0x01;
        
        // TWI Control Register  TWCR
        //  - Bit 7  TWINT: TWI Interrupt Flag
        //  - Bit 6  TWEA: TWI Enable Acknowledge Bit
        //  - Bit 5  TWSTA: TWI START Condition Bit
        //  - Bit 4  TWSTO: TWI STOP Condition Bit
        //  - Bit 3  TWWC: TWI Write Collision Flag
        //  - Bit 2  TWEN: TWI Enable Bit
        //  - Bit 1  Res: Reserved Bit
        //  - Bit 0  TWIE: TWI Interrupt Enable
        TWCR=0x05;
}                           */



/*
void i2c_wvalue(char cn)
{
        TWCR = cn;
        while (!(TWCR & TWINT));
        printf("\r\n TWSR = 0x%X ; TWCR = %X \r\n ",TWSR,TWCR);
}   

unsigned char eep_read(char addr)
{
        i2c_wvalue(TWINT | TWSTA | TWEN);
        TWDR=SLA_W;
        i2c_wvalue(TWINT | TWEN | TWEA);
        TWDR=addr;
        i2c_wvalue(TWINT | TWEN | TWEA);
        i2c_wvalue(TWINT | TWSTA | TWEN);
        TWDR=SLA_R;
        i2c_wvalue(TWINT | TWEN | TWEA);
        return TWDR;
}

void i2cinit(void)
{
        TWSR=0x00;
        TWBR=0x02;
        TWAR=0x00;
        TWCR=0x04;
}       */